"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createConditionTest = void 0;
const lodash_1 = require("lodash");
function createConditionTest(condition) {
    const conditionAsArray = (0, lodash_1.flatten)([condition]);
    return (p) => conditionAsArray.reduce((b, c) => b ||
        (typeof c === 'string' && p.startsWith(c)) ||
        (c instanceof RegExp && c.test(p)) ||
        (typeof c === 'function' && c(p)), false);
}
exports.createConditionTest = createConditionTest;
//# sourceMappingURL=conditionTest.js.map