import { startCase } from 'lodash';

import { readJsonSync } from './readJson';

export const { name: packageName } = readJsonSync<{ name: string }>(
  require.resolve('../package.json')
);

export const pluginName = startCase(packageName);

export const reNodeModules = /[\\/]node_modules[\\/]/;
export const reEsmFile = /\.mjs$/;

export const baseNodeModules = 'node_modules';

export const moduleType = 'commonjs-module';

export const extJs = '.js';
export const extJson = '.json';

export const sourceTypeAsset = 'asset';

export const stageVeryEarly = -1000000;
